<?php
/** 
  * Miniforum - plugin for BLOG:CMS and Nucleus CMS
  * 2005, (c) Josef Adamcik (blog.pepiino.info)
  *
  *
  *
  * This program is free software; you can redistribute it and/or
  * modify it under the terms of the GNU General Public License
  * as published by the Free Software Foundation; either version 2
  * of the License, or (at your option) any later version.
  * 
  * History:
  *  v0.5.1
  *    - fix IE/Opera refresh problem
  *    - dynamic div for shoutbox
  *  v0.5.2
  *    - better onload hook for Firefox/IE/Opera
  *    - change script to support multiple shoutbox
  *
  * todo:
  *  - XHTML 4.01 compliant
  *  
*/


global $DIR_PLUGINS;
if (!is_dir($DIR_PLUGINS)) die('System is not configured properly - NP_MiniForum.php');
require_once($DIR_PLUGINS.'miniforum/lang.php');
if (!function_exists('sql_fetch_array')) include ($DIR_PLUGINS.'miniforum/nucdb.php'); //compatibilyty with Nucleus CMS

require_once($DIR_PLUGINS.'miniforum/emoticons.php');

class NP_MiniForum extends NucleusPlugin {

 function getNAME() { return 'MiniForum';  }
 function getAuthor()  { return 'Josef Adamcik, Edmond Hui (admun)';  }
 function getURL() {  return 'http://wakka.xiffy.nl/miniforum'; }
 function getVersion() { return '0.5.2'; }
 function getMinNucleusVersion() { return 300; }
 function getDescription() { 
  return MF_PLUGIN_DESCRIPTION;
 }
 
 function install() {
   $this->createOption('MFQuickMenu',MF_ENABLE_QICK_MENU,'yesno','yes');
   $this->createOption('MFPostsPg',MF_POSTS_TO_SHOW,'text','15');
   $this->createOption('MFConvertNl',MF_COVERT_NL,'yesno','yes');
   $this->createOption('MFMaxLineLength',MF_MAX_LINE_LENGTH,'text','70');
   $this->createOption('MFUrlsToLinks',MF_COVERT_URLS,'yesno','no');
   $this->createOption('MFEmoToImg',MF_COVERT_EMOTICONS,'yesno','no');
   $this->createOption('MFEmoDir',MF_EMOTICONS_DIR, 'text','admin/plugins/fancytext/smiles');
   $this->createOption("MFPostsHeader",MF_POST_LIST_HEADER,"textarea","<h2><%title%></h2><p><%description%></p><%navigation%> <ul class=\"miniforum\">");
   $this->createOption("MFPostBody",MF_POST_BODY,"textarea","<li><%name%> [ <%date%> | <%time%> ]<br /><%body%></li>");
   $this->createOption("MFPostsFooter",MF_POST_LIST_FOOT,"textarea","</ul><br /><%navigation%>");
   $this->createOption("MFFormLogged",MF_FORM_LOGGED,"textarea","<textarea class='formfield' name='BODY' rows='3' cols='20'></textarea><br /><input type='submit' value='Send' />");
   $this->createOption("MFForm",MF_FORM_NOTLOGGED,"textarea",
          "<label>name<input class='formfield' type='text' name='UNAME' /></label><br />".
          "<label>url<input class='formfield' type='text' name='URL' /></label><br />".
          "<textarea class='formfield' name='BODY' rows='3' cols='20'></textarea><br />".
          "<input class='formbutton' type='submit' value='Send' />");
   $this->createOption("MFNavigation",MF_NAVIGATION,"textarea","<div class=\"forum\">[<%first-page%>][<%prev-page%>] (Page: <%cur-page%> from <%page-count%>) [<%next-page%>][<%last-page%>]</div>");       
   $this->createOption("MFName",MF_NAME_NOURL,"textarea","<strong><%user-name%></strong>");
   $this->createOption("MFNameLink",MF_NAME_URL,"textarea","<a href='<%user-link%>'><%user-name%></a>");
   $this->createOption("MFMemberName",MF_MEMBER_NAME,"textarea","<a class='member' href='<%user-link%>'><%user-name%></a>");
   $this->createOption("MFDate", MF_DATE, "text", "d. m. y");
   $this->createOption("MFTime", MF_TIME, "text", "H:i");
   $this->createOption("MFNextPage",MF_NEXTPAGE,"text","Next");
   $this->createOption("MFPreviousPage",MF_PREVIOUSPAGE,"text","Previous");
   $this->createOption("MFFirstPage",MF_FIRSTPAGE,"text","First");
   $this->createOption("MFLastPage",MF_LASTPAGE,"text","Last");
   
   // create tables
   sql_query("CREATE TABLE `".sql_table("plug_miniforum_post")."` (
             `id` INT UNSIGNED NOT NULL AUTO_INCREMENT ,
             `idforum` INT UNSIGNED NOT NULL ,
             `uname` VARCHAR( 20 ) NOT NULL ,
             `url` VARCHAR( 30 ) ,
             `memberid` INT,
             `time` INT NOT NULL ,
             `body` TEXT NOT NULL ,
             PRIMARY KEY ( `id` ) ,
             FULLTEXT (
                 `body` 
                 )
             )");
   sql_query("CREATE TABLE  `".sql_table("plug_miniforum_forum")."` (
              `id` INT NOT NULL AUTO_INCREMENT ,
              `title` VARCHAR( 20 ) ,
              `description` TEXT,
              `short_name` VARCHAR( 20 ) NOT NULL ,
              PRIMARY KEY ( `id` ) ,
              UNIQUE (
                `short_name` 
                ))");
                
   sql_query("INSERT INTO `".sql_table("plug_miniforum_forum")."` (id,title,description,short_name) VALUES(1,'default','default forum','default')");
 }

 function unInstall() { 
   sql_query("DROP TABLE `".sql_table('plug_miniforum_forum')."`" );
   sql_query("DROP TABLE `".sql_table('plug_miniforum_post')."`" );
      
   $this->deleteOption('MFQuickMenu');
   $this->deleteOption('MFPostsPg');
   $this->deleteOption('MFMaxLineLength');   
   $this->deleteOption("MFPostsHeader");
   $this->deleteOption("MFPostBody");
   $this->deleteOption("MFPostsFooter");
   $this->deleteOption("MFName");
   $this->deleteOption("MFNameLink");
   $this->deleteOption("MFMemberName");
   $this->deleteOption("MFDate");
   $this->deleteOption("MFTime");
   $this->deleteOption("MFFormLogged");
   $this->deleteOption("MFForm");
   $this->deleteOption("MFNextPage");
   $this->deleteOption("MFPreviousPage");
   $this->deleteOption("MFFirstPage");
   $this->deleteOption("MFLastPage");
   $this->deleteOption("MFCovertNl");
   $this->deleteOption('MFEmoToImg');
   $this->deleteOption('MFUrlsToLinks');
   $this->deleteOption('MFEmoDir');
   
 }
 
 function getTableList() {	
    return array(sql_table('plug_miniforum_forum'),
                 sql_table('plug_miniforum_post')); 
 }          
 
 function supportsFeature($feature) {
		switch($feature) {
			case 'SqlTablePrefix':
				return 1;
			default:
				return 0;
		}
	}

	
	
 function getEventList() { 
    return array('QuickMenu','PreDeleteMember'); 
 }   	
	
 function event_QuickMenu(&$data) {
    global $member;
    if (($this->getOption('MFQuickMenu') != 'yes')|| (!$member->isAdmin())) return;
    array_push(
        $data['options'],
        array(
            'title' => MF_QM_TITLE,
            'url' => $this->getAdminURL(),
            'tooltip' => MF_QM_TOOLTIP
        )
    );
  }	
  
  // before deleting member, set all his posts in all forums as nonmeber
  function event_PreDeleteMember(&$data) {
    $memberid = $data['member']->getID();
    $query = "UPDATE `".sql_table('plug_miniforum_post')."` SET memberid='0' WHERE memberid='$memberid'";
    sql_query($query); 
  }
  
  function hasAdminArea()
  {
    return 1;
  }


 
 /**
 * Returns forum id as number. used to convert forum short name, which you can use when 
 * calling a plugin instead of forum number.
 * Returns -1, when forum doesn't exist.
 */ 
 function getForumId($forumId) {
    if (is_numeric($forumId)) {
        //We maybe have right forum id yet. Only check, if it exists.
        $query = "SELECT * FROM `".sql_table(plug_miniforum_forum)."` WHERE `id`=".$forumId;
        $result = sql_query($query);
        if (sql_num_rows($result) == 0) return -1;
    } else {
       //We have to find forum id number.
       $query = "SELECT id FROM `".sql_table(plug_miniforum_forum)."` WHERE short_name='".$forumId."'"; 
       $result = sql_query($query);
       if (sql_num_rows($result) == 0) return -1;
       else {
           $result = sql_fetch_array($result);
           $forumId = $result['id'];
       }
    }
    return $forumId;
 }
 
 /**
 * Removes parametr given parameter from url. Isn't case sensitive!!
 * e.g.: url: http://something.com?param1=value1&param2=value2&param3=value3
 *       paramName: param2
 *       returns:  http://something.com?param1=value1&param3=value3 
 */
 function rmUrlParam($url,$paramName) {
    $url = trim($url); $paramName=trim($paramName);
    if (!$ppos = strpos($url,$paramName)) return $url;
    //find next &
    $pnextamp = strpos($url,'&',$ppos);
    //look what character is before paramName
    $befpar = substr($url,$ppos - 1,1);
    //echo "$ppos a $pnextamp b $befpar <br/>";
    if ($befpar == '&') {
        $result = substr($url,0,$ppos - 1);
        if ($pnextamp) $result .= substr ($url, $pnextamp, strlen($url) - $pnextamp);
    } else if (($befpar == '?') && (!$pnextamp) ) {
        $result = substr($url,0,$ppos - 1);
    } else if (($befpar == '?') && ($pnextamp) ) {
        $result = substr($url,0,$ppos);
        $result .= substr($url,$pnextamp + 1,strlen($url) - $pnextamp - 1);
    } else $result = $url;
        
    return $result;
 }    
 
 /**
 * Converts all linebreaks to <br /> tags. (Used when adding post. see doAction())
 */   
 function convertNlToBr($text) {
    if ($this->getOption('MFConvertNl') == 'yes') {
        return str_replace("\n",'<br />',$text);
    } else return $text;
 }

 /**
 * Prepares navigation code and returns it as string
 */
 function prepareNavigation($forumId,$page,$postsPerPage) {
    $query = "SELECT COUNT(*) FROM ".sql_table('plug_miniforum_post')." WHERE `idforum`=".$forumId;
    $result = sql_fetch_array(sql_query($query));
    $pageCount = ceil($result[0] / $postsPerPage);
    $desturl = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    $desturl = $this->rmUrlParam($desturl,'PAGE');
    if (strpos($desturl,'?')) $param = '&PAGE='; else $param='?PAGE=';
  
    if ($page != 1) $firstPage = "<a href='".$desturl.$param.(1)."'>".$this->getOption('MFFirstPage')."</a>";
    else $firstPage = $this->getOption('MFFirstPage');
    if ($page > 1) $prevPage = "<a href='".$desturl.$param.($page - 1)."'>".$this->getOption('MFPreviousPage')."</a>";
    else $prevPage = $this->getOption('MFPreviousPage');
    if ($page < $pageCount) $nextPage = "<a href='".$desturl.$param.($page + 1)."'>".$this->getOption('MFNextPage')."</a>";
    else $nextPage = $this->getOption('MFNextPage');
    if ($page != $pageCount) $lastPage = "<a href='".$desturl.$param.($pageCount)."'>".$this->getOption('MFLastPage')."</a>";
    else $lastPage = $this->getOption('MFLastPage');
    
    $navigation = $this->getOption('MFNavigation');
    $from = array("<%first-page%>","<%prev-page%>","<%cur-page%>","<%page-count%>","<%next-page%>","<%last-page%>");
    $to = array($firstPage,$prevPage,$page,$pageCount,$nextPage,$lastPage);
    for ($i =0; $i < sizeof($from); $i++) {
        $navigation = str_replace($from[$i],$to[$i],$navigation);
    }
   
    return $navigation;
 }
      
 
 /**
 * If word in $text is longer then $max, it'll be breaked into parts separated by '-'.
 * Can be simplier, but we have to do more work for the utf-8 encoding, if it's used.
 
 */
 function wrapLongWords($text,$maxLength) {
    if (strtolower(_CHARSET) == 'utf-8') {
        $bUsingUtf = true; //test, if utf-8 is used. 
    } else {
        $bUsingUtf = false; 
    }
    
    $wordStart = 0; // character, where current word started
    $wordLength = 0; // length of word (we need this value separated, becouse text can be in utf-8)
    $lastCopy = 0; //points to the first character, which isn't copied to result yet

    for ($i = 0; $i < strlen($text);$i++) {//go through whole text
        if ($bUsingUtf && (($value = ord($text{$i})) > 127)){ //handles utf-8 coded string
           if($value >= 192 && $value <= 223)
               $i++;
           elseif($value >= 224 && $value <= 239)
               $i = $i + 2;
           elseif($value >= 240 && $value <= 247)
               $i = $i + 3;
        }
		
		if (($text{$i} == '<') && ($text{$i+1} == 'a')) { //don't wrap link! 
			$endLink = strpos($text,'>',$i);
			$i = $endLink;
			$wordStart = $i+1;
			$wordLength = 0;
			continue;
		}
		if (($text{$i} == '<') && ($text{$i+1} == '/') && ($text{$i+2} == 'a') ) {//end of link
			$i = $i + 3;
			$wordStart = $i+1;
			$wordlLength = 0;
			continue;
		}
		
        if (($text{$i} == ' ') || ($text{$i} == '-') || ($text{$i} == "\n")) { //here starts new word
            $wordStart = $i + 1;
            $wordLength = 0;
        }
        if ($wordLength >= $maxLength - 1) { //word is too long 
              $newText .= substr($text,$lastCopy ,$i - $lastCopy + 1).'- ';
              $wordStart = $i + 1;
              $lastCopy = $i + 1;
              $wordLength = 0;
        }
        $wordLength++;
//        echo $wordLenght."<br />";
    }
    $newText .= substr($text,$lastCopy);
    return $newText;
 }
 
 
 /**
 */
 function insertEmoticons($text) {
	 if ($this->getOption('MFEmoToImg') == 'yes') {

		 global $emoticons;
		 $iconDir = $this->getOption('MFEmoDir');
		 $textEm = array_keys($emoticons);
		
		 foreach($textEm as $key) {
			 $text = str_replace($key, "<img src='$iconDir/{$emoticons[$key]}' alt='$key' />", $text);
		 }
	 }
     return $text;
 }
 
 
 /**
 * Converts urls in text to links.
 */
 function urlToHref($text) {
	 if ($this->getOption('MFUrlsToLinks') == 'yes') {
		//  protocol://address/path/
	   $text = ereg_replace("[a-zA-Z]+://([.]?[a-zA-Z0-9_/-?&%=])*", "<a href=\"\\0\">\\0</a>", $text);
	
	   //  www.something
	   $text = ereg_replace("(^| )(www([.]?[a-zA-Z0-9_/-?&%=])*)", "\\1<a href=\"http://\\2\">\\2</a>", $text);
		 
	 }
	 
	 return $text;
 }
 
 
 /**
 * Shows posts from forum using tempelate from options.
 */
 function showPosts($forumId = 1) {

    //reads forum information 
    $query = "SELECT * FROM `".sql_table(plug_miniforum_forum)."` WHERE `id`=".$forumId;
    $result = sql_query($query);
    $forum = sql_fetch_array($result);

    // detect current page and number of posts to show per page    
    $page = requestVar('PAGE');
    if (!is_numeric($page) || ($page <= 0)) $page = 1;
    $postsPerPage = $this->getOption('MFPostsPg');
    if (($postsPerPage <= 0)) $postsPerPage = 15;


    //prepare forum header and footer
    $from = array('<%title%>','<%description%>','<%navigation%>');
    $to = array($forum['title'],$forum['description'],$this->prepareNavigation($forumId,$page,$postsPerPage));
    $header = $this->getOption('MFPostsHeader');
    $footer = $this->getOption('MFPostsFooter');
    for ($i = 0; $i<sizeof($from); $i++) {
        $header = str_replace($from[$i],$to[$i],$header);
        $footer = str_replace($from[$i],$to[$i],$footer);
    }
    echo $header; //and print header

    //reads posts 
    $query = "SELECT * FROM `".sql_table("plug_miniforum_post")."` WHERE `idforum`=".$forumId." ORDER BY id DESC LIMIT  ".(($page - 1) * $postsPerPage).",".$postsPerPage;
    $result = sql_query($query);

    //shows posts
    while ($post = sql_fetch_array($result)) {
        
        //process tag tempelate for name
        if (MEMBER::existsID(intval($post['memberid']))){
            $mem = MEMBER::createFromId($post['memberid']); 
            $uname = $mem->getDisplayName();
            $url = "?member=".$uname;
            $nametmpl = $this->getOption('MFMemberName');
        } else {
            $uname = $post['uname'];
            $url = $post['url'];
            if ($url == "") {  
                $nametmpl = $this->getOption('MFName'); 
            }
            else { 
                $nametmpl = $this->getOption('MFNameLink'); 
            }
        }
        $from = array("<%user-name%>","<%user-link%>");    
        $to = array($uname,$url);
             
        for ($i=0; $i < sizeof($from); $i++) {
              $nametmpl = str_replace($from[$i],$to[$i],$nametmpl);
        }
        
		$body = $post['body'];
		$body = $this->urlToHref($body);
		$body = $this->wrapLongWords($body,$this->getOption('MFMaxLineLength'));
		$body = $this->insertEmoticons($body);
		
        //aply tempelates
        $from = array("<%name%>","<%date%>","<%time%>","<%body%>");
        $to = array($nametmpl,
                    date($this->getOption('MFDate'),$post['time']),
                    date($this->getOption('MFTime'),$post['time']),
                    $body
              );
        $pbody = $this->getOption('MFPostBody');
        for ($i=0;$i<sizeof($from);$i++) $pbody=str_replace($from[$i],$to[$i],$pbody);    
        echo $pbody;
    }
    echo $footer;
    
 }

  /**
  * Prints a form.
  */
  function showForm($forumId = 1) {
    $desturl = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    global $member;
    echo "<form class='miniforum' method='post' action='action.php' >
          <fieldset>  
          <input type='hidden' name='action' value='plugin' />
          <input type='hidden' name='name' value='MiniForum' />
          <input type='hidden' name='type' value='addPost' />
          <input type='hidden' name='FORUMID' value='".$forumId."' />
          <input type='hidden' name='desturl' value='".$desturl."' />";
    if ($member->isLoggedIn()) {
        echo $this->getOption('MFFormLogged');
    } else {
        echo $this->getOption('MFForm');    
   } 
   echo "</fieldset></form>";
  }  
    

 /**
 * $what : what to do. Posible values: 
 *       script - instrument the javascript in header section that perform refresh
 *       ShowPosts - shows posts from forum
 *       ShowForm - shows add post form
 * $forumId : short_name or numerical id of forum.                        
 */
 function doSkinVar($skinType,$what, $forumId = 1) {
    global $CONF;
    $forumName = $forumId;

    if (($forumId = $this->getForumId($forumId)) == -1) {
        echo "<p class='error'>NP_MiniForum: ".MF_FORUM_DOESNT_EX.".</p>";
        return ;
        }
    switch(strtolower($what)) {
        case "script" :
?>
<!-- code from http://dutchcelt.nl/weblog/article/ajax_for_weblogs/ -->
<script type="text/javascript">
  var ajax<? echo $forumId; ?>=false;
  /*@cc_on @*/
  /*@if (@_jscript_version >= 5)
  try {
    ajax<? echo $forumId; ?> = new ActiveXObject("Msxml2.XMLHTTP");
  } catch (e) {
    try {
      ajax<? echo $forumId; ?> = new ActiveXObject("Microsoft.XMLHTTP");
    } catch (E) {
      ajax<? echo $forumId; ?> = false;
    }
  }
  @end @*/
  if (!ajax<? echo $forumId; ?> && typeof XMLHttpRequest!='undefined') {
    ajax<? echo $forumId; ?> = new XMLHttpRequest();
  }

  function getMyHTML<? echo $forumId; ?>() {

      var temp<? echo $forumId; ?> = '<? echo $forumId; ?>';
      var serverPage<? echo $forumId; ?> = '<? echo $CONF['IndexURL']; ?>action.php?action=plugin&name=MiniForum&type=updatePost&forumId='+temp<? echo $forumId; ?>;
      var obj<? echo $forumId; ?> = document.getElementById('mf'+temp<? echo $forumId; ?>);
      ajax<? echo $forumId; ?>.open("GET", serverPage<? echo $forumId; ?>);
      ajax<? echo $forumId; ?>.onreadystatechange = function() {
        if (ajax<? echo $forumId; ?>.readyState == 4 && ajax<? echo $forumId; ?>.status == 200) {
          obj<? echo $forumId; ?>.innerHTML = ajax<? echo $forumId; ?>.responseText;
        }
      }
      ajax<? echo $forumId; ?>.send(null);

    MFstartRefresh<? echo $forumId; ?>();
  }

  function MFstartRefresh<? echo $forumId; ?>() {
    //.. reload every 5 minutes
    setTimeout("getMyHTML<? echo $forumId; ?>()",10*1000);
  }

  // trick learnt from wp wordspew 
  if(typeof window.addEventListener != 'undefined') {
    //.. gecko, safari, konqueror and standard
    window.addEventListener('load', MFstartRefresh<? echo $forumId; ?>, false);
  }
  else if(typeof document.addEventListener != 'undefined')
  {
    //.. opera 7
    document.addEventListener('load', MFstartRefresh<? echo $forumId; ?>, false);
  }
  else if(typeof window.attachEvent != 'undefined')
  {
    //.. win/ie
    window.attachEvent('onload', MFstartRefresh<? echo $forumId; ?>);
  }
</script>
<?
            break;
        case "showposts" :
?>
<div id="mf<? echo $forumId; ?>">
<? $this->showPosts($forumId); ?>
</div>
<?
            break;
        case "showform" :
            $this->showForm($forumId);
            break;    
        default:
            echo "<p class='error'>NP_MiniForum: ".MF_UNKNOWN_OPTION.".";
            break;
   }
 }
 
 
 
 /**
 * This function is called by action.php when adding new post to forum.

 */
 function doAction($actionType) {
    if ($actionType == "addPost") {
        global $member;
        
        if ($member->isLoggedIn()) {
            $uname = $member->getDisplayName();
            $url = $member->getUrl();
            if (trim($url) == "http://") $url = "";
            $memberid = $member->getID();
        } else {
            $uname = sql_escape(strip_tags(undoMagic(requestVar('UNAME'))));
            if ($member->isNameProtected($uname)) return  str_replace('$uname',$uname,MF_NAME_PROTECTED);
            $url = sql_escape(strip_tags(undoMagic(requestVar('URL'))));
            $memberid = 0;
        }
        
        $body = htmlspecialchars(undoMagic(requestVar('BODY')),ENT_NOQUOTES);
        $body = sql_escape($this->convertNlToBr($body));
        
        $forumId = sql_escape(strip_tags(undoMagic(requestVar('FORUMID'))));

        if ($uname == "") return MF_NAME_MISSING;
        if ($body == "") return MF_TEXT_MISSING;
        
        //prepare www or mail adres 
        if ($url != "") {
            if (substr_count($url,"@") == 1) { //i think, it should be e-mail adress
                //so add mailto:
                $url="mailto:".$url;
            } else if (substr_count($url,"http://") == 0) {
                    $url="http://".$url;
            }
        }
        
        //check, if the body of message isn't same like 5 last posts - if it si, it can be reload of page, or spam
        $query = "SELECT MAX(id) FROM `".sql_table('plug_miniforum_post')."` WHERE (idforum=".$forumId.") AND (uname='".$uname."')";
        $result = sql_fetch_array(sql_query($query));
        if ($result[0] !=0 ) {
            $query = "SELECT `body` FROM `".sql_table('plug_miniforum_post')."` WHERE `id`=".$result[0];    
            $result = sql_fetch_array(sql_query($query));
            if (trim($result['body']) == trim($body)) $body = "";
        }
       
        if ($body != "") { 
             $query = "INSERT INTO `".sql_table('plug_miniforum_post')."` (idforum,uname,url,body,time,memberid) VALUES (".$forumId.",'".$uname."','".$url."','".$body."',".time().",".$memberid.")";
             $result = sql_query($query);
        }
        
        $desturl = $this->rmUrlParam(requestVar('desturl'),'PAGE');
       
        header('Expires: 0');
        header('Pragma: no-cache');
	    Header('Location: '.$desturl);
	    
	    exit();
        
    } elseif ($actionType == "updatePost") {
        $forumId = requestVar('forumId');
        if (($forumId = $this->getForumId($forumId)) == -1) {
            echo "<p class='error'>NP_MiniForum: ".MF_FORUM_DOESNT_EX.".</p>";
            return ;
        }
        $this->showPosts($forumId);
    } else {
        return "Unknown action (NP_miniforum)";
    }
 }

}
?>
